--[[
-- Sonar Library
-- \i[Cu
-- version 1.0 (2009-01-05)
Author:
	silica as ~̐l
	http://winter.sgv417.jp/
Document:
	http://pc3merchant.net/ai_antenna/index.php?Dev%2FLib%2Fsonar.lua
--]]
sonar = {	-- ID̈ʒuAA\
	O = {0, 0},	-- a datum point: _
	CELL = 4,	-- ԁiPʁFZj
	RADIUS = 15,	-- ͈͔aiPʁFZj, WFʑS(31x31)
	NUMPAD = {	-- Numpad, A numeric keypad
		{-1,-1}, { 0,-1}, { 1,-1},	-- Num1: 1, 2, 3
		{-1, 0}, { 0, 0}, { 1, 0},	-- Num2: 4, 5, 6
		{-1, 1}, { 0, 1}, { 1, 1},	-- Num3: 7, 8, 9
	},
	COMPASS = {	-- Compass, NEWS
		"SW",  "S",  "SE",	-- Num1: 1, 2, 3
		 "W",  "O",   "E",	-- Num2: 4, 5, 6
		"NW",  "N",  "NE",	-- Num3: 7, 8, 9
	},
	AIM = {	-- ڕW
		"DL",  "D",  "DR",	-- Num1: 1, 2, 3
		 "L",  "C",   "R",	-- Num2: 4, 5, 6
		"UL",  "U",  "UR",	-- Num3: 7, 8, 9
	},
	xGRID = {0, 3, 6},	-- Add X ratei{Zj
	yGRID = {1, 2, 3},	-- Add Y ratei{Zj
	xNEWS = {"S", "O", "N"},	-- South, North
	yNEWS = {"W", "O", "E"},	-- West, East
	xAIMS = {"D", "C", "U"},	-- Down, Center, Up
	yAIMS = {"L", "C", "R"},	-- Left, Center, Right
}

-- lID擾
function sonar:owner(id)
	return GetV(0, id)	-- V_OWNER: l
end

-- ID̍W擾
function sonar:position(id)
	return GetV(1, id)	-- V_POSITION: W
end

-- init parameter
function sonar:new(id)
	self.id = id	-- IDiftHgFlj
	self.x, self.y = self:position(self.id)
end

-- Relative  (self.x, self.y, x, y)
-- Absolute  (x1, y1, x2, y2)
-- id2(x2, y2) Ƃ (self.x, self.y)  id1(x1, x2)
function sonar:relative(id1, id2)
	local x1, y1, x2, y2
	if (id2 == nil) then	-- Relative: 
		x1 = self.x; y1 = self.y
		x2, y2 = self:position(id1)
	else	-- Absolute: 
		x1, y1 = self:position(id1)
		x2, y2 = self:position(id2)
	end

	return x1, y1, x2, y2
end

--[[
-- _id(x, y)
W[x1, y1](5)猩[x2, y2]̈ʒuieL[j

Compass: [[S, O, N], [W, O, E]]
Aim    : [[D, C, L], [L, C, R]]
Area   : 14 is (14+1+14)x(14+1+14) = 29x29 cell(area)
Cell   :  4 is (4+1+4) = 9 cell(center)
Ԃl: 1-9
--]]
function sonar:divine(number, grid, cell)
	if cell == nil then
		cell = self.CELL	-- 4 is 9 cell(4+1+4)
	end
	if(-cell > number) then
		return grid[1]
	elseif(-cell <= number and number <= cell) then
		return grid[2]
	else	-- number < cell
		return grid[3]
	end
end

-- W[x1, y1]i_j猩[x2, y2]̕p
-- Ԃl: 1-9
function sonar:PositionNumpad(x1, y1, x2, y2, cell)
	local x = self:divine(x2 - x1, self.xGRID, cell)
	local y = self:divine(y2 - y1, self.yGRID, cell)

	return (x+y)
end

-- W[x1, y1]i_j猩[x2, y2]̕p
-- Ԃl: N/S, E/W
function sonar:PositionCompass(x1, y1, x2, y2)
	local xnews = self:divine(x2 - x1, self.xNEWS, 0)
	local ynews = self:divine(y2 - y1, self.yNEWS, 0)

	return xnews, ynews
end

-- W[x1, y1]i_j猩[x2, y2]̕p
-- Ԃl: U/D, L/R
function sonar:PositionAim(x1, y1, x2, y2)
	local xaim = self:divine(x2 - x1, self.xAIMS, 0)
	local yaim = self:divine(y2 - y1, self.yAIMS, 0)

	return xaim, yaim
end

-- id1(5)猩id2̈ʒuieL[j
-- id2ꍇ͌_猩id1̕
-- Ԃl: 1-9
-- id2cellw肵ꍇ: sonar:Numpad(id, , 3)
function sonar:numpad(id1, id2, cell)
	local x1, y1, x2, y2 = self:relative(id1, id2)

	return self:PositionNumpad(x1, y1, x2, y2, cell)
end

-- id1(5)猩id2̕ikj
-- id2ꍇ͌_猩id1̕
-- Ԃl: N/S, E/W
function sonar:compass(id1, id2, cell)
	local x1, y1, x2, y2 = self:relative(id1, id2)

	return self:PositionCompass(x1, y1, x2, y2, cell)
end

-- id1(5)猩id2̕i㉺Ej
-- id2ꍇ͌_猩id1̕
-- Ԃl: U/D, L/R
function sonar:aim(id1, id2, cell)
	local x1, y1, x2, y2 = self:relative(id1, id2)

	return self:PositionAim(x1, y1, x2, y2, cell)
end

--[[
-- ikj
	id1: ID or ΏIDiid2 = nil̎j
	id2: ΏID or nil
--]]
function sonar:news(id1, id2)
	local x1, y1, x2, y2 = self:relative(id1, id2)
	local ns, we = self:PositionCompass(x1, y1, x2, y2)
	local x = math.abs(x2-x1)
	local y = math.abs(y2-y1)

	ns = string.format("%s%02d", ns, x)
	we = string.format("%s%02d", we, y)

	return string.format("%3s, %4s", ns, we)
end

--[[
-- i㉺Ej
	id1: ID or ΏIDiid2 = nil̎j
	id2: ΏID or nil
--]]
function sonar:aims(id1, id2)
	local x1, y1, x2, y2 = self:relative(id1, id2)
	local ns, we = self:PositionAim(x1, y1, x2, y2)
	local x = math.abs(x2-x1)
	local y = math.abs(y2-y1)

	return string.format("%s%02d, %s%02d", ns, x, we, y)
end

--[[
-- ̊ID猩ΏID̑Έʒu
-- Kv: what.lua, mobdata.lua
	id1: ID or ΏIDiid2 = nil̎j
	id2: ΏID or nil
	o: O : eL[, k쐔, 
	: T[Lv60 : 9, N06, E06
--]]
function sonar:information(id1, id2)
	if (id2 == nil) then	-- Relative: 
		id = id1
	else	-- Absolute: 
		id = id2
	end
	local name = what:is(id)
	local str = self:news(id1, id2)
	local	dir = self:numpad(id1, id2)

	-- ID:7 O:16Ő񂵂ďo
	return string.format("%7d(%16s) : %s, %s", id, name, dir, str)
end

--[[
-- w肳ꂽIDnZȓɂSĂActorԂ
Defalut:
	rad = 15
--]]
function sonar:getActor4ID(actors, id, rad)
	local act = {}
	local i = 1
	if(id == nil) then id = self.id end	-- w肪ꍇAWID
	if(rad == nil) then rad = self.RADIUS end	-- w肪ꍇʑS
	x, y = self:position(id)

	for k, v in pairs(actors) do
		local x1, y1 = self:position(v)
		if (x-rad <= x1 and x1 <= x+rad and y-rad <= y1 and y1 <= y+rad) then
			act[i] = actors[k]
			i = i+1
		end
	end

	return act
end

--[[
-- Sonar Search
actors𕶎ɏo͂B
--]]
function sonar:actors(actors, rad)
	local str = "     ID(      O      ) :Num,NS , WE\n"

	for k, v in pairs(actors) do
		str = str..self:information(v).."\n"	-- message.txt1so
	end

	return str
end

-- actorsۑ
-- óFIDAOAAWAHP, SP
function sonar:saveactors(actors, filename, mode)
	fp = io.open(filename, mode or "w")
	if(fp == nil) then return end	-- ߂ȂƂ
	fp:write("Date: "..os.date("%Y-%m-%d %H:%M:%S").."\n")
	fp:write("+-------+---------------------------------+----------+---+-----+-----+\n")
	fp:write("| ID    | Name                            |   X,   Y | M | HP  | SP  |\n")
	fp:write("+-------+---------------------------------+----------+---+-----+-----+\n")
	for index, actorid in ipairs(actors) do
		-- IDXgAW
		fp:write(string.format("|%7d", actorid))
		fp:write(string.format("| %-32s", what:is(actorid)))
		fp:write(string.format("|%10s", sonar:news(sonar.id, actorid)))
		fp:write(string.format("|%2d ", GetV(V_MOTION, actorid)))
		fp:write(string.format("|%5d", GetV(V_HP, actorid)))
		fp:write(string.format("|%4d |", GetV(V_SP, actorid)))
		fp:write("\n")
	end
	fp:write("+-------+---------------------------------+----------+---+-----+-----+\n\n")
	fp:close()
end

-- eL[̐kɕϊ
function sonar:Numpad2Compass(num)
	return self.COMPASS[num]
end

-- eL[̐㉺Eɕϊ
function sonar:Numpad2Aim(num)
	return self.AIM[num]
end

-- (x1, y1)(x2, y2)̍ŒZi~j
function sonar:CircleXY(x1, y1, x2, y2)
	return math.floor(math.sqrt((x1-x2)^2+(y1-y2)^2))
end

-- id1id2̍ŒZi~j
function sonar:CircleID(id1, id2)
	return self:CircleXY(self:relative(id1, id2))
end

-- (x1, y1)(x2, y2)̍ŒZi`j
function sonar:SquareXY(x1, y1, x2, y2)
	local xpos = math.abs(x1 - x2)	-- XW̋
	local ypos = math.abs(y1 - y2) -- YW̋

	if(xpos >= ypos) then
		return xpos
	else
		return ypos
	end
end

-- id1id2̍ŒZi`j
function sonar:SquareID(id1, id2)
	return self:SquareXY(self:relative(id1, id2))
end

-- Alias: `
sonar.pos = sonar.position
sonar.xy2num  = sonar.PositionNumpad	-- Numpad
sonar.xy2com  = sonar.PositionCompass	-- Compass
sonar.xy2aim  = sonar.PositionAim	-- Aim
sonar.num = sonar.numpad
sonar.com = sonar.compass
sonar.info = sonar.information	-- Information
sonar.num2com = sonar.Numpad2Compass
sonar.num2aim = sonar.Numpad2Aim
sonar.cirxy = sonar.CircleXY
sonar.cirid = sonar.CircleID
sonar.squxy = sonar.SquareXY
sonar.squid = sonar.SquareID
